using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.SceneManagement;
using UnityEngine.UI;

public class MainManager : MonoBehaviour
{
    public GameObject Main;
    [Header(", Ÿ")]
    public Button btnBackTitle;
    public Text txtQuizScript;
    public int nQuizTotalCount;
    public int nQuizNowStep;
    public bool isQuizLoad;

    [Header("  - 1")]
    public GameObject objAnswerType1Set;
    public Button btnO;
    public Button btnX;
    public bool isChooseO;
    public bool isChooseX;

    [Header("  - 2")]
    public GameObject objAnswerType2Set;
    public Button btnAnswer1;
    public Button btnAnswer2;
    public Button btnAnswer3;
    public Button btnAnswer4;
    public Text txtAnswer1;
    public Text txtAnswer2;
    public Text txtAnswer3;
    public Text txtAnswer4;
    public bool isChoose1;
    public bool isChoose2;
    public bool isChoose3;
    public bool isChoose4;

    [Header("  - 3")]
    public GameObject objAnswerType3Set;
    public InputField ipfAnswer;
    public Button btnAnswerIpf;
    public bool isSubmitIpf;

    [Header("˾â")]
    public GameObject objResultPopupSet;
    public GameObject objCorrectAnswer;
    public GameObject objWrongAnswer;
    public Button btnResultConfirm;

    GameDataManager gameDataManager;

    public bool isCorrect;
    public GameObject objTotalResult;
    public Text txtTotalResult;
    public int nTotalCorrectAnswerCount;

    public void InitAll()
    {
        txtQuizScript.text = "";
        isQuizLoad = false;

        objAnswerType1Set.SetActive(false);
        objAnswerType2Set.SetActive(false);
        objAnswerType3Set.SetActive(false);

        isChooseO = false;
        isChooseX = false;

        isChoose1 = false;
        isChoose2 = false;
        isChoose3 = false;
        isChoose4 = false;

        isSubmitIpf = false;

        ipfAnswer.text = "";

        isCorrect = false;

        objResultPopupSet.SetActive(false);
        objCorrectAnswer.SetActive(false);
        objWrongAnswer.SetActive(false);
        objTotalResult.SetActive(false);

        Debug.Log("ʱȭ ");
    }

    // Start is called before the first frame update
    void awake()
    {
        InitAll();
    }
    void Start()
    {
        gameDataManager = GameObject.Find("GameDataManager_DontDestroy").GetComponent<GameDataManager>();

        btnBackTitle.onClick.AddListener(() => //ŸƲ ư ư ̺Ʈ 
        {
            Main.SetActive(false);
            Debug.Log("Title  ε");
        });

        btnO.onClick.AddListener(() => //  O ư ̺Ʈ 
        {
            isChooseO = true;
        });
        btnX.onClick.AddListener(() => //  X ư ̺Ʈ 
        {
            isChooseX = true;
        });

        btnAnswer1.onClick.AddListener(() => //  1 ư ̺Ʈ 
        {
            isChoose1 = true;
        });
        btnAnswer2.onClick.AddListener(() => //  2 ư ̺Ʈ 
        {
            isChoose2 = true;
        });
        btnAnswer3.onClick.AddListener(() => //  3 ư ̺Ʈ 
        {
            isChoose3 = true;
        });
        btnAnswer4.onClick.AddListener(() => //  4 ư ̺Ʈ 
        {
            isChoose4 = true;
        });

        btnAnswerIpf.onClick.AddListener(() => // ְ   ư ̺Ʈ 
        {
            isSubmitIpf = true;
        });

        btnResultConfirm.onClick.AddListener(() => //  Ȯ ư ̺Ʈ 
        {
            if (isCorrect)
            {
                nTotalCorrectAnswerCount += 1;
                isCorrect = false;
            }

            if (nQuizNowStep >= nQuizTotalCount)
            {
                Main.SetActive(false);
                
            }
            else
            {
                NextQuizLoad();
            }
        });

        InitAll();

        Debug.Log(gameDataManager.data_Quiz.Count);
        nQuizTotalCount = gameDataManager.data_Quiz.Count;
        nQuizNowStep = 0;

        txtTotalResult.text = "";
        nTotalCorrectAnswerCount = 0;
    }

    public void NextQuizLoad()
    {
        InitAll();

        nQuizNowStep += 1;

        if (nQuizNowStep >= nQuizTotalCount)
        {
            txtTotalResult.text = nTotalCorrectAnswerCount.ToString() + "/" + nQuizTotalCount.ToString() + " ";
            objTotalResult.SetActive(true);
            objResultPopupSet.SetActive(true);

        }
    }

    // Update is called once per frame
    void Update()
    {
        if (nQuizNowStep < nQuizTotalCount)
        {
            if (isQuizLoad == false) //   
            {
                txtQuizScript.text = gameDataManager.data_Quiz[nQuizNowStep][""].ToString();

                switch (gameDataManager.data_Quiz[nQuizNowStep]["Ÿ"].ToString())
                {
                    case "1": // Ÿ1 - O,X 
                        objAnswerType1Set.SetActive(true);
                        break;

                    case "2": // Ÿ2 -  
                        objAnswerType2Set.SetActive(true);
                        txtAnswer1.text = gameDataManager.data_Quiz[nQuizNowStep][""].ToString().Split('/')[0];
                        txtAnswer2.text = gameDataManager.data_Quiz[nQuizNowStep][""].ToString().Split('/')[1];
                        txtAnswer3.text = gameDataManager.data_Quiz[nQuizNowStep][""].ToString().Split('/')[2];
                        txtAnswer4.text = gameDataManager.data_Quiz[nQuizNowStep][""].ToString().Split('/')[3];
                        break;

                    case "3": // Ÿ3 - ְ 
                        objAnswerType3Set.SetActive(true);
                        break;
                }

                isQuizLoad = true;
            }
            else  //   
            {
                switch (gameDataManager.data_Quiz[nQuizNowStep]["Ÿ"].ToString())
                {
                    case "1": // Ÿ1 - O,X 
                        if (isChooseO || isChooseX)
                        {
                            objResultPopupSet.SetActive(true);

                            if ((gameDataManager.data_Quiz[nQuizNowStep][""].ToString() == "0" && isChooseO == true) ||
                                (gameDataManager.data_Quiz[nQuizNowStep][""].ToString() == "1" && isChooseX == true))
                            {
                                objCorrectAnswer.SetActive(true);
                                isCorrect = true;
                            }
                            else
                            {
                                objWrongAnswer.SetActive(true);
                            }
                        }
                        break;

                    case "2": // Ÿ2 -  
                        if (isChoose1 || isChoose2 || isChoose3 || isChoose4)
                        {
                            objResultPopupSet.SetActive(true);

                            if ((gameDataManager.data_Quiz[nQuizNowStep][""].ToString() == "1" && isChoose1 == true) ||
                                (gameDataManager.data_Quiz[nQuizNowStep][""].ToString() == "2" && isChoose2 == true) ||
                                (gameDataManager.data_Quiz[nQuizNowStep][""].ToString() == "3" && isChoose3 == true) ||
                                (gameDataManager.data_Quiz[nQuizNowStep][""].ToString() == "4" && isChoose4 == true))
                            {
                                objCorrectAnswer.SetActive(true);
                                isCorrect = true;
                            }
                            else
                            {
                                objWrongAnswer.SetActive(true);
                            }
                        }
                        break;

                    case "3": // Ÿ3 - ְ 
                        if (isSubmitIpf)
                        {
                            objResultPopupSet.SetActive(true);

                            if (ipfAnswer.text == gameDataManager.data_Quiz[nQuizNowStep][""].ToString())
                            {
                                objCorrectAnswer.SetActive(true);
                                isCorrect = true;
                            }
                            else
                            {
                                objWrongAnswer.SetActive(true);
                            }
                        }
                        break;
                }
            }
        }

    }
}
